Deploy using capistrano. Everything goes well, and then during deployment: start (during deployment: cold), it causes an error:
* ←[32m2013-03-14 15:03:05 executing `deploy:start'←[0m
* ←[33mexecuting "/etc/init.d/unicorn_appname start"←[0m
servers: ["XXX.XXX.131.4"]
[XXX.XXX.131.4] executing command
** [out :: XXX.XXX.131.4] sh: /etc/init.d/unicorn_appname: not found
←[2;37mcommand finished in 1572ms←[0m
failed: "sh -c '/etc/init.d/unicorn_appname start'" on XXX.XXX.131.4
This file exists. Here it contains:
#!/bin/sh
set -e
TIMEOUT=${TIMEOUT-60}
APP_ROOT=/root/apps/appname/current
PID=$APP_ROOT/tmp/pids/unicorn.pid
CMD="cd $APP_ROOT; bundle exec unicorn -D -c $APP_ROOT/config/unicorn.rb -E production"
AS_USER=root
set -u
OLD_PIN="$PID.oldbin"
sig () {
test -s "$PID" && kill -$1 `cat $PID`
}
oldsig () {
test -s $OLD_PIN && kill -$1 `cat $OLD_PIN`
}
run () {
if [ "$(id -un)" = "$AS_USER" ]; then
eval $1
else
su -c "$1" - $AS_USER
fi
}
case "$1" in
start)
sig 0 && echo >&2 "Already running" && exit 0
run "$CMD"
;;
stop)
sig QUIT && exit 0
echo >&2 "Not running"
;;
force-stop)
sig TERM && exit 0
echo >&2 "Not running"
;;
restart|reload)
sig HUP && echo reloaded OK && exit 0
echo >&2 "Couldn't reload, starting '$CMD' instead"
run "$CMD"
;;
upgrade)
if sig USR2 && sleep 2 && sig 0 && oldsig QUIT
then
n=$TIMEOUT
while test -s $OLD_PIN && test $n -ge 0
do
printf '.' && sleep 1 && n=$(( $n - 1 ))
done
echo
if test $n -lt 0 && test -s $OLD_PIN
then
echo >&2 "$OLD_PIN still exists after $TIMEOUT seconds"
exit 1
fi
exit 0
fi
echo >&2 "Couldn't upgrade, starting '$CMD' instead"
run "$CMD"
;;
reopen-logs)
sig USR1
;;
*)
echo >&2 "Usage: $0 <start|stop|restart|upgrade|force-stop|reopen-logs>"
exit 1
;;
esac
Trying to run the command via ssh (sh -c '/etc/init.d/unicorn_appname start'), I encountered the same error.
What could be the reason?
source
share